/* ss-core/sshw.h
 *
 * Interface to ss-hw.
 *
 * Copyright (C) 2003, 2004
 * Andy Goth     <unununium@openverse.com>
 *
 * This code is available under the GNU General Public License; see COPYING. */

#ifndef SEEN_SSCORE_SSHW_H
#define SEEN_SSCORE_SSHW_H

#include <stdint.h>

#include "evlist/evlist.h"
#include "ss-core/core.h"

extern int sshw_init(device_t* dev, core_t* core);

extern int sshw_send_inv_delay(device_t* dev, int delay);
extern int sshw_send_rf_field (device_t* dev, int enable);

#endif

/* vim: set ts=4 sts=4 sw=4 tw=80 et: */
