# ss-gui/module.mk

PROGRAMS += $(DIR)/ss-gui
TARGETS += $(DIR)/fltk.cc $(DIR)/fltk.h

# Generate GUI source code from .fl file.
$(DIR)/fltk.cc $(DIR)/fltk.h: $(DIR)/fltk.fl
	@echo "* FL  $<"
	$(HUSH)cd $(DIR); fluid -c fltk.fl; mv fltk.cxx fltk.cc

# XXX.
CXXFLAGS += $(shell fltk-config --cxxflags)

SRC-$(DIR)/ss-gui     := $(DIR)/fltk.cc $(DIR)/misc.cc
LIBS-$(DIR)/ss-gui    := $(shell fltk-config --ldflags --libs)\
                         $(shell pkg-config sqlite --libs)
# LLIBS-$(DIR)/ss-gui := evlist/evlist.a prjlibs/prjlibs.a

ss-gui: $(DIR)/ss-gui

# vim: set ts=4 sw=4 tw=80 noet:
