/* ss-hw/user.h
 *
 * User interface functions.
 *
 * Copyright (C) 2003, 2004
 * Andy Goth     <unununium@openverse.com>
 *
 * This code is available under the GNU General Public License; see COPYING. */

#ifndef SEEN_SSHW_USER_H
#define SEEN_SSHW_USER_H

#include <stdint.h>

#include "evlist/evlist.h"

extern int user_init(device_t* dev, device_t* rfid);

extern int user_send_pressure(device_t* dev, int a, int b, int c, int d);
extern int user_send_doors   (device_t* dev, int a, int b);
extern int user_send_tag_add (device_t* dev, uint64_t uid, uint32_t type);
extern int user_send_tag_del (device_t* dev, uint64_t uid);

#endif

/* vim: set ts=4 sts=4 sw=4 tw=80 et: */
